Name:		python-twisted
Version:	16.3.2
Release:	1.0.cf%{?dist}
Summary:	Event-based framework for Internet applications
Group:		Development/Libraries
License:	MIT
URL:		http://twistedmatrix.com/
Source0:	http://twistedmatrix.com/Releases/Twisted/16.3/Twisted-%{version}.tar.bz2
BuildRequires:	coreutils
BuildRequires:	gcc
BuildRequires:	python2-devel >= 2.7
BuildRequires:	python-zope-interface >= 3.6.0
BuildRequires:	python-crypto >= 2.6.1
BuildRequires:	pyOpenSSL >= 0.10
BuildRequires:	sed
BuildRequires:	python-setuptools

# Bring all provided resources back into the main package namespace
Obsoletes:	python-twisted-conch < %{version}-%{release}
Provides:	python-twisted-conch = %{version}-%{release}
Obsoletes:	python-twisted-core < %{version}-%{release}
Provides:	python-twisted-core = %{version}-%{release}
Obsoletes:	python-twisted-core-doc < %{version}-%{release}
Provides:	python-twisted-core-doc = %{version}-%{release}
Obsoletes:	python-twisted-core-zsh < %{version}-%{release}
Provides:	python-twisted-core-zsh = %{version}-%{release}
Obsoletes:	python-twisted-lore < %{version}-%{release}
Provides:	python-twisted-lore = %{version}-%{release}
Obsoletes:	python-twisted-mail < %{version}-%{release}
Provides:	python-twisted-mail = %{version}-%{release}
Obsoletes:	python-twisted-names < %{version}-%{release}
Provides:	python-twisted-names = %{version}-%{release}
Obsoletes:	python-twisted-news < %{version}-%{release}
Provides:	python-twisted-news = %{version}-%{release}
Obsoletes:	python-twisted-runner < %{version}-%{release}
Provides:	python-twisted-runner = %{version}-%{release}
Obsoletes:	python-twisted-web < %{version}-%{release}
Provides:	python-twisted-web = %{version}-%{release}
Obsoletes:	python-twisted-web2 < %{version}-%{release}
Provides:	python-twisted-web2 = %{version}-%{release}
Obsoletes:	python-twisted-words < %{version}-%{release}
Provides:	python-twisted-words = %{version}-%{release}

# Capture previous namespace
Obsoletes:	Twisted < %{version}-%{release}
Provides:	Twisted = %{version}-%{release}
Obsoletes:	twisted < %{version}-%{release}
Provides:	twisted = %{version}-%{release}

# python-twisted-conch
Requires:	pyOpenSSL >= 0.10
Requires:	python-crypto >= 2.6.1
Requires:	python-pyasn1
Requires:	tkinter

# python-twisted-core
Requires:	python-zope-interface >= 3.6.0
Requires:	pyserial

# Don't want provides for python shared objects
%{?filter_provides_in: %filter_provides_in %{python_sitearch}/twisted/.*\.so}
%{?filter_setup}

%description
Twisted is an event-based framework for Internet applications.	It includes a
web server, a telnet server, a chat server, a news server, a generic client
and server for remote object access, and APIs for creating new protocols and
services. Twisted supports integration of the Tk, GTK+, Qt or wxPython event
loop with its main event loop. The Win32 event loop is also supported, as is
basic support for running servers on top of Jython.

%prep
%setup -q -n Twisted-%{version}

%build
CFLAGS="%{optflags}" python2 setup.py build

%install
rm -rf %{buildroot}
python setup.py install -O1 --skip-build --root %{buildroot}

# cfsupport is support for MacOSX Core Foundations, so we can delete it
rm -rf %{buildroot}%{python_sitearch}/twisted/internet/cfsupport

# iocpreactor is a win32 reactor, so we can delete it
rm -rf %{buildroot}%{python_sitearch}/twisted/internet/iocpreactor

# no-manual-page-for-binary
mkdir -p %{buildroot}%{_mandir}/man1/
for s in conch core mail; do
	cp -a docs/$s/man/*.1 %{buildroot}%{_mandir}/man1/
done

# devel-file-in-non-devel-package
rm -v %{buildroot}%{python_sitearch}/twisted/runner/portmap.c
rm -v %{buildroot}%{python_sitearch}/twisted/test/raiser.c
rm -v %{buildroot}%{python_sitearch}/twisted/python/_sendmsg.c

# pem-certificate
rm -v %{buildroot}%{python_sitearch}/twisted/internet/test/fake_CAs/thing1.pem
rm -v %{buildroot}%{python_sitearch}/twisted/mail/test/server.pem
rm -v %{buildroot}%{python_sitearch}/twisted/test/server.pem
rm -v %{buildroot}%{python_sitearch}/twisted/internet/test/fake_CAs/chain.pem
rm -v %{buildroot}%{python_sitearch}/twisted/internet/test/fake_CAs/thing2.pem
rm -v %{buildroot}%{python_sitearch}/twisted/internet/test/fake_CAs/thing2-duplicate.pem

# non-executable-script
chmod -c +x %{buildroot}%{python_sitearch}/twisted/mail/test/pop3testserver.py
chmod -c +x %{buildroot}%{python_sitearch}/twisted/trial/test/scripttest.py

# non-standard-executable-perm
chmod -c 755 %{buildroot}%{python_sitearch}/twisted/python/_sendmsg.so
chmod -c 755 %{buildroot}%{python_sitearch}/twisted/runner/portmap.so
chmod -c 755 %{buildroot}%{python_sitearch}/twisted/test/raiser.so

%check
# bin/trial twisted
# can't get this to work within the buildroot yet due to multicast
# https://twistedmatrix.com/trac/ticket/7494

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc CONTRIBUTING NEWS README.rst
%{_bindir}/cftp
%{_bindir}/ckeygen
%{_bindir}/conch
%{_bindir}/mailmail
%{_bindir}/pyhtmlizer
%{_bindir}/tkconch
%{_bindir}/trial
%{_bindir}/twistd
%{_mandir}/man1/cftp.1*
%{_mandir}/man1/ckeygen.1*
%{_mandir}/man1/conch.1*
%{_mandir}/man1/mailmail.1*
%{_mandir}/man1/pyhtmlizer.1*
%{_mandir}/man1/tkconch.1*
%{_mandir}/man1/trial.1*
%{_mandir}/man1/twistd.1*
%{python_sitearch}/twisted/
%{python_sitearch}/Twisted-%{version}-py*.egg-info/

%changelog
* Fri Aug 19 2016 Paul Howarth <paul@city-fan.org> - 16.3.2-1.0.cf
- Update to 16.3.2 (Twisted Web bugfix; see NEWS for details)

* Tue Aug 16 2016 Paul Howarth <paul@city-fan.org> - 16.3.1-1.0.cf
- Update to 16.3.1 (security fixes in Twisted Web; see NEWS for details)

* Thu Jul  7 2016 Paul Howarth <paul@city-fan.org> - 16.3.0-1.0.cf
- Update to 16.3.0 (see NEWS for details)

* Mon May 23 2016 Paul Howarth <paul@city-fan.org> - 16.2.0-1.0.cf
- Update to 16.2.0 (see NEWS for details)

* Mon Apr 11 2016 Paul Howarth <paul@city-fan.org> - 16.1.1-1.0.cf
- Update to 16.1.1
  - twisted.web.http.Request once again has a reference to the HTTPFactory
    that created it, the absence of which was preventing log messages from
    being created (#8272)

* Mon Apr  4 2016 Paul Howarth <paul@city-fan.org> - 16.1.0-1.0.cf
- Update to 16.1.0 (see NEWS for details)

* Tue Mar 15 2016 Paul Howarth <paul@city-fan.org> - 16.0.0-1.0.cf
- Update to 16.0.0 (see NEWS for details)

* Mon Nov 30 2015 Paul Howarth <paul@city-fan.org> - 15.5.0-1.0.cf
- Update to 15.5.0 (see NEWS for details)

* Sat Sep  5 2015 Paul Howarth <paul@city-fan.org> - 15.4.0-1.0.cf
- Update to 15.4.0 (see NEWS for details)
- No need to detect egg-info as it's always there

* Tue Aug  4 2015 Paul Howarth <paul@city-fan.org> - 15.3.0-1.0.cf
- Update to 15.3.0 (see NEWS for details)
- Twisted Lore dropped in favour of Sphinx

* Tue May 26 2015 Paul Howarth <paul@city-fan.org> - 15.2.1-1.0.cf
- Update to 15.2.1 (see NEWS for details)

* Tue May 19 2015 Paul Howarth <paul@city-fan.org> - 15.2.0-1.0.cf
- Update to 15.2.0 (see NEWS for details)

* Tue Apr 14 2015 Paul Howarth <paul@city-fan.org> - 15.1.0-1.0.cf
- Update to 15.1.0 (see NEWS for details)

* Mon Feb  2 2015 Paul Howarth <paul@city-fan.org> - 15.0.0-1.0.cf
- Update to 15.0.0 (see NEWS for details)

* Thu Jan 29 2015 Paul Howarth <paul@city-fan.org> - 14.0.2-1.1.cf
- Obsolete/Provide python-twisted-core-doc as well

* Thu Dec  4 2014 Paul Howarth <paul@city-fan.org> - 14.0.2-1.0.cf
- Update to 14.0.2
- Ship Twisted as a fully featured package without subpackages on the advice
  of upstream and to mirror what pypi provides

* Mon Nov 11 2013 Paul Howarth <paul@city-fan.org> - 13.2.0-1.0.cf
- Update to 13.2.0, with requires for version 13.2.0 of sub-projects

* Tue Jul  2 2013 Paul Howarth <paul@city-fan.org> - 13.1.0-1.0.cf
- Update to 13.1.0, with requires for version 13.1.0 of sub-projects

* Thu Apr  4 2013 Paul Howarth <paul@city-fan.org> - 13.0.0-1.0.cf
- Update to 13.0.0, with requires for version 13.0.0 of sub-projects

* Thu Dec 27 2012 Paul Howarth <paul@city-fan.org> - 12.3.0-1.0.cf
- Update to 12.3.0, with requires for version 12.3.0 of sub-projects

* Mon Sep  3 2012 Paul Howarth <paul@city-fan.org> - 12.2.0-1.0.cf
- update to 12.2.0, with requires for version 12.2.0 of sub-projects

* Wed Jun  6 2012 Paul Howarth <paul@city-fan.org> - 12.1.0-1.0.cf
- Update to 12.1.0, with requires for version 12.1.0 of sub-projects
- Drop %%defattr, redundant since rpm 4.4

* Mon Feb 13 2012 Paul Howarth <paul@city-fan.org> - 12.0.0-1.0.cf
- Update to 12.0.0, with requires for version 12.0.0 of sub-projects
- Twisted now requires python 2.5

* Mon Jan  9 2012 Paul Howarth <paul@city-fan.org> - 11.1.0-2.0.cf
- Fedora 17 mass rebuild

* Fri Nov 18 2011 Paul Howarth <paul@city-fan.org> - 11.1.0-1.0.cf
- Update to 11.1.0, with requires for version 11.1.0 of sub-projects

* Mon Apr  4 2011 Paul Howarth <paul@city-fan.org> - 11.0.0-1.0.cf
- Update to 11.0.0, with requires for version 11.0.0 of sub-projects

* Tue Nov 30 2010 Paul Howarth <paul@city-fan.org> - 10.2.0-1.0.cf
- Update to 10.2.0, with requires for version 10.2.0 of sub-projects

* Tue Nov  9 2010 Paul Howarth <paul@city-fan.org> - 10.1.0-3.1.cf
- Move egg-info file from %%{python_sitearch} to %%{python_sitelib}
- Go back to being a noarch package

* Mon Nov  8 2010 Paul Howarth <paul@city-fan.org> - 10.1.0-3.0.cf
- Add egg-info file
- No longer a noarch package
- BR/R python2 >= 2.4

* Mon Jul  5 2010 Paul Howarth <paul@city-fan.org> - 10.1.0-1.0.cf
- Update to 10.1.0, with requires for version 10.1.0 of sub-projects
- Twisted now requires python >= 2.4

* Thu Mar  4 2010 Paul Howarth <paul@city-fan.org> - 10.0.0-1.0.cf
- Update to 10.0.0, with requires for version 10.0.0 of sub-projects

* Wed Nov 25 2009 Paul Howarth <paul@city-fan.org> - 9.0.0-1.0.cf
- Update to 9.0.0, with requires for version 9.0.0 of sub-projects

* Tue Aug 11 2009 Paul Howarth <paul@city-fan.org> - 8.2.0-3.0.cf
- Define RPM macros in global scope

* Sun Jul 26 2009 Paul Howarth <paul@city-fan.org> - 8.2.0-2.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri Jan 16 2009 Paul Howarth <paul@city-fan.org> - 8.2.0-1.0.CF
- Update to 8.2.0, with requires for version 8.2.0 of sub-projects

* Fri Jan 16 2009 Paul Howarth <paul@city-fan.org> - 8.1.0-2.0.CF
- Minor spec file cleanups in line with Fedora version

* Mon May 19 2008 Paul Howarth <paul@city-fan.org> - 8.1.0-1
- Update to 8.1.0, with requires for version 8.1.0 of sub-projects except
  runner, still at 8.0.0

* Tue Apr  1 2008 Paul Howarth <paul@city-fan.org> - 8.0.1-1
- Update to 8.0.1, with requires for version 8.0.0 of sub-projects

* Thu Jan 11 2007 Paul Howarth <paul@city-fan.org> - 2.5.0-1
- Dispense with %%{python} and %%{origname} macros
- Require appropriate minimum versions of the other Twisted packages
- Preserve timestamp of README.fedora
- Various cosmetic changes

* Wed Jan 03 2007 Thomas Vander Stichele <thomas at apestaart dot org>
- 2.4.0-2
- Add a README.fedora
- Made noarch, since it doesn't actually install any python twisted/ module
  code
- Fixed provides/obsoletes

* Wed Jun 07 2006 Thomas Vander Stichele <thomas at apestaart dot org>
- 2.4.0-1
- This is now a pure umbrella package

* Mon Oct 10 2005 Jeff Pitman <symbiont+pyvault@berlios.de> - 2.1.0-1
- Upstream release

* Tue Aug 23 2005 Jeff Pitman <symbiont+pyvault@berlios.de> - 2.0.1-1
- Upstream release

* Mon Apr 04 2005 Jeff Pitman <symbiont+pyvault@berlios.de> - 2.0.0-2
- Add zsh support

* Fri Mar 25 2005 Jeff Pitman <symbiont+pyvault@berlios.de> - 2.0.0-1
- Final release

* Thu Mar 17 2005 Jeff Pitman <symbiont+pyvault@berlios.de> - 2.0.0-0.2.a3
- Dropped web2

* Wed Mar 16 2005 Jeff Pitman <symbiont+pyvault@berlios.de> - 2.0.0-0.1.a3
- Upstream release

* Sat Mar 12 2005 Jeff Pitman <symbiont+pyvault@berlios.de> - 2.0.0-0.1.a2
- New prerelease; FE versioning

* Mon Feb 07 2005 Jeff Pitman <symbiont+pyvault@berlios.de> - 2.0.0a1-1
- Prep for split

* Fri Aug 20 2004 Jeff Pitman <symbiont+pyvault@berlios.de> - 1.3.0-1
- New version

* Mon Apr 19 2004 Jeff Pitman <symbiont+pyvault@berlios.de> - 1.2.0-3
- Vaultize

* Mon Apr 12 2004 Jeff Pitman <symbiont+pyvault@berlios.de> - 1.2.0-2
- Require pyOpenSSL, SOAPpy, openssh-clients, crypto, dia so trial can run

